# wso2wsf::Options Class Reference
[Options]

class Options Holder for operation client options. This is used by the other classes in this package to configure various aspects of how a client communicates with a service. It exposes a number of predefined properties as part of the API (with specific getXXX and setXXX methods), and also allows for arbitrary named properties to be passed using a properties map with the property name as the key value. Instances of this class can be chained together for property inheritance, so that if a property is not set in one instance it will check its parent for a setting. More...

`#include <Options.h>`

List of all members.

## Public Member Functions
void | setXMLParserReset (bool paser_reset)
| Options ()
| ~Options ()
WSF_EXTERN std::string | getFaultTo ()
WSF_EXTERN std::string | getFrom ()
WSF_EXTERN std::string | getMessageId ()
WSF_EXTERN std::string | getReplyTo ()
WSF_EXTERN void | setEnableREST (bool enable)
WSF_EXTERN void | setUseSeparateListener (bool use_separate_listener)
WSF_EXTERN long | getTimeout ()
WSF_EXTERN std::string | getTo ()
WSF_EXTERN void | setFaultTo (std::string fault_to)
WSF_EXTERN void | setFrom (std::string from)
WSF_EXTERN void | setTo (std::string to)
WSF_EXTERN void | setMessageId (std::string message_id)
WSF_EXTERN bool | setProperty (Property *property)
WSF_EXTERN void | setReplyTo (std::string reply_to)
WSF_EXTERN void | setTimeout (long timeout)
WSF_EXTERN void | addReferenceParameter (OMElement *reference_parameter)
WSF_EXTERN soap_version | getSoapVersion ()
WSF_EXTERN void | setSoapVersion (soap_version version)
WSF_EXTERN void | setEnableMTOM (bool enable)
WSF_EXTERN bool | getEnableMTOM ()
WSF_EXTERN bool | setAction (std::string action)
WSF_EXTERN void | setHTTPMethod (std::string http_method)
WSF_EXTERN axis2_options_t * | getAxis2Options ()
WSF_EXTERN bool | setTestHTTPAuth (bool testHTTPAuth)
WSF_EXTERN bool | setTestProxyAuth (bool testProxyAuth)
WSF_EXTERN bool | setHTTPAuthInfo (std::string username, std::string password, std::string authType)
WSF_EXTERN bool | setProxyAuthInfo (std::string username, std::string password, std::string authType)
## Friends
class | ServiceClient

## Detailed Description

class Options Holder for operation client options. This is used by the other classes in this package to configure various aspects of how a client communicates with a service. It exposes a number of predefined properties as part of the API (with specific getXXX and setXXX methods), and also allows for arbitrary named properties to be passed using a properties map with the property name as the key value. Instances of this class can be chained together for property inheritance, so that if a property is not set in one instance it will check its parent for a setting.

## Constructor & Destructor Documentation

wso2wsf::Options::Options | ( |  | ) |

Creates the options struct with or without given parent.

wso2wsf::Options::~Options | ( |  | ) |

destructor frees resources.

## Member Function Documentation

WSF_EXTERN void wso2wsf::Options::addReferenceParameter | ( | OMElement * | reference_parameter | ) |

Adds a WSA reference parameter.

Parameters:

  | reference_parameter | pointer to reference parameter in the form of an AXIOM tree. options takes over the ownership of the struct.

WSF_EXTERN axis2_options_t* wso2wsf::Options::getAxis2Options | ( |  | ) |

Returns the axis2_options used within Options class

WSF_EXTERN bool wso2wsf::Options::getEnableMTOM | ( |  | ) |

Gets Enable/disable MTOM status.

Returns:
  true if MTOM enabled, else false.

WSF_EXTERN std::string wso2wsf::Options::getFaultTo | ( |  | ) |

Gets WSA fault to address.

Returns:
  pointer to fault to address if set, else NULL.

WSF_EXTERN std::string wso2wsf::Options::getFrom | ( |  | ) |

Gets WSA from address.

Returns:
  pointer to from address if set, else NULL.

WSF_EXTERN std::string wso2wsf::Options::getMessageId | ( |  | ) |

Gets message ID.

Returns:
  pointer to message ID string if set, else NULL.

WSF_EXTERN std::string wso2wsf::Options::getReplyTo | ( |  | ) |

Gets WSA reply to address.

Returns:
  pointer to reply to address if set, else NULL.

WSF_EXTERN soap_version wso2wsf::Options::getSoapVersion | ( |  | ) |

Gets SOAP version.

Returns:
  AXIOM_SOAP11 if SOAP version 1.1 is in use, else AXIOM_SOAP12.

WSF_EXTERN long wso2wsf::Options::getTimeout | ( |  | ) |

Gets the wait time after which a client times out in a blocking scenario. The default is AXIS2_DEFAULT_TIMEOUT_MILLISECONDS.

Returns:
  timeout in milliseconds.

WSF_EXTERN std::string wso2wsf::Options::getTo | ( |  | ) |

Gets WSA to address.

Returns:
  pointer to, to address if set, else NULL.

WSF_EXTERN bool wso2wsf::Options::setAction | ( | std::string | action | ) |

configure client to use the specified the SOAP/Addressing action

Parameters:

  | action,The | soap action

Returns:
  true if the action is successfully set, false otherwise.

WSF_EXTERN void wso2wsf::Options::setEnableMTOM | ( | bool | enable | ) |

Enable/disable MTOM handling.

Parameters:

  | enable | true if MTOM is to be enabled, if not, false.

WSF_EXTERN void wso2wsf::Options::setEnableREST | ( | bool | enable | ) |

Sets the bool value indicating whether to enable REST or not.

Parameters:

  | enable | bool value indicating whether to enable REST or not, true to enable, false to disable.

WSF_EXTERN void wso2wsf::Options::setFaultTo | ( | std::string | fault_to | ) |

Sets fault to address.

Parameters:

  | fault_to | pointer to, fault to address. Options takes over the ownership of the struct.

WSF_EXTERN void wso2wsf::Options::setFrom | ( | std::string | from | ) |

Sets from address.

Parameters:

  | from | pointer to, from address. Options takes over the ownership of the struct.

WSF_EXTERN bool wso2wsf::Options::setHTTPAuthInfo | ( | std::string | username,
|  | std::string | password,
|  | std::string | authType |
| ) |  |  |

Sets HTTP authentication information.

Parameters:

  | username | string representing username
  | password | string representing password
  | authType | use "Basic" to force basic authentication and "Digest" to force digest authentication or NULL for not forcing authentication

Returns:
  true on success, else false

WSF_EXTERN void wso2wsf::Options::setHTTPMethod | ( | std::string | http_method | ) |

Sets the HTTP method to be used

Parameters:

  | http_method | string representing HTTP method to use, can be either AXIS2_HTTP_GET or AXIS2_HTTP_POST

WSF_EXTERN void wso2wsf::Options::setMessageId | ( | std::string | message_id | ) |

Sets message ID.

Parameters:

  | message_id | pointer to message_id struct.

WSF_EXTERN bool wso2wsf::Options::setProperty | ( | Property * | property | ) |

Sets the properties.

Parameters:

  | property | pointer to properties object.

Returns:
  true on success, else false.

WSF_EXTERN bool wso2wsf::Options::setProxyAuthInfo | ( | std::string | username,
|  | std::string | password,
|  | std::string | authType |
| ) |  |  |

Sets proxy authentication information.

Parameters:

  | username | string representing username
  | password | string representing password
  | authType | use "Basic" to force basic authentication and "Digest" to force digest authentication or NULL for not forcing authentication

Returns:
  AXIS2_SUCCESS on success, else AXIS2_FAILURE

WSF_EXTERN void wso2wsf::Options::setReplyTo | ( | std::string | reply_to | ) |

Sets reply to address.

Parameters:

  | reply_to | pointer to endpoint reference struct representing reply to address. options takes over the ownership of the struct.

WSF_EXTERN void wso2wsf::Options::setSoapVersion | ( | soap_version | version | ) |

Sets SOAP version.

Parameters:

  | version | soap version, either AXIOM_SOAP11 or AXIOM_SOAP12.

WSF_EXTERN bool wso2wsf::Options::setTestHTTPAuth | ( | bool | testHTTPAuth | ) |

Sets the bool value indicating whether to test whether HTTP Authentication is required or not.

Parameters:

  | testHTTPAuth | bool value indicating whether to test or not, true to enable, false to disable

Returns:
  true on success, false otherwise.

WSF_EXTERN bool wso2wsf::Options::setTestProxyAuth | ( | bool | testProxyAuth | ) |

Sets the bool value indicating whether to test whether Proxy Authentication is required or not.

Parameters:

  | testProxyAuth | bool value indicating whether to test or not, true to enable, false to disable

Returns:
  AXIS2_SUCCESS on success, else AXIS2_FAILURE

WSF_EXTERN void wso2wsf::Options::setTimeout | ( | long | timeout | ) |

Sets timeout in Milli seconds.

Parameters:

  | timeout | timeout in milli seconds.

Returns:
  true on success, else false.

WSF_EXTERN void wso2wsf::Options::setTo | ( | std::string | to | ) |

sets from address.

Parameters:

  | to | pointer to , to address. Options takes over the ownership of the struct.

WSF_EXTERN void wso2wsf::Options::setUseSeparateListener | ( | bool | use_separate_listener | ) |

Sets the bool value indicating whether to use a separate listener or not.

Parameters:

  | use_separate_listener | bool value indicating whether to use a separate listener or not.

void wso2wsf::Options::setXMLParserReset | ( | bool | paser_reset | ) |

Sets xml parser reset. By default, set to true.

Parameters:

  | paser_reset | is a boolean value.

## Friends And Related Function Documentation

friend class ServiceClient`[friend]`

The ServiceClient Class can access private resources of this class.

The documentation for this class was generated from the following file:

- Options.h